Linux Support

Big picture view

There are two major directions in UE4 Linux development - the first being helping people, who might not have had prior experience with Linux, to easily support it as an application platform (SteamOS, embedded systems), while the second - giving Linux folks at large ability to use and develop with Unreal Engine on this platform natively.

For the first group, we want to provide smooth, "console-like" experience, where they just need to install a Linux "SDK" in order to compile and package Linux games without having to switch from Mac or Windows.

The second group - where you probably belong - is expected to have more knowledge and be prepared to delve into nitty-gritty details, if needed.

Depending on which group you are from, you may be interested in either cross-compilation or native development. Be advised that cross-compilation is a more traveled road, since it is used in production, while native compilation is for more advanced users - you want to be present on community IRC channel (#ue4linux on Freenode), especially if you compile on an uncommon Linux distro.

Note that while cross-development from Windows to Linux is supported (which is especially crucial for non-Intel Linux architectures), the opposite direction (cross-developing for Windows on Linux) is not presently possible.

Of course, we welcome any help you might be able to offer to further improve Unreal on Linux.

Epic Games Launcher

Currently, there is no possibility to access the launcher on Linux systems. It is not known when and if the launcher will be provided for the platform.

Supported architectures

Linux x86-64

This is the primary architecture we are supporting.

Linux AArch64/AArch32

Supported primarily for servers; albeit packaging a game is also possible (but requires desktop OpenGL which is only available on NVidia Jetson).

Distros

Binary compatibility

On Intel architectures, the cross-compiled binary should run on any distro with glibc 2.12 (CentOS 6.x) for Unreal 4.13 and earlier or with glibc 2.17 (Cent OS 7.x) for Unreal 4.14 and above. For binaries that are built natively, binary compatibility is not guaranteed and generally you should expect to be able to run them only on a system exactly like yours.

For compatibility on non-Intel architectures see cross-toolchain README files for glibc versions.

Suitability for native development

The recommended distro for developing Unreal on Linux is Ubuntu. The LTS version that is the closest to the release of a particular Unreal version works best (i.e. 14.04 for UE4 4.11 and lower, 16.04 for UE 4.12 and above).

Users of other systems, especially Gentoo and Arch Linux are expected to be knowledgeable about system components and be able to find discrepancies between Ubuntu and their system that can prevent Unreal build process or the engine itself from running.

Community IRC channel

Although this is not an official support outlet, people from irc://irc.freenode.net/UE4Linux might be able to offer some help. You can find archived IRC discussions at http://teemperor.de/ue4-logs/ue4linux/